/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.sql.impl;

import com.jiuqi.sql.impl.RW;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class DBaseFieldHeader {
    public static final int headLength = 50;
    String fieldName;
    char dataType;
    int fieldLength;
    byte scale;
    byte[] reserved2 = new byte[8];
    long incValue;
    byte[] reserved3 = new byte[2];

    public void readFromStream(InputStream stream) throws IOException {
        this.fieldName = RW.readString(stream, 32).trim();
        this.dataType = (char)stream.read();
        this.fieldLength = RW.readWord(stream);
        this.scale = RW.read(stream);
        stream.read(this.reserved2);
        this.incValue = RW.readDWord(stream);
        stream.read(this.reserved3);
    }

    public void writeToStream(OutputStream stream) throws IOException {
        RW.writeString(stream, this.fieldName.trim(), 32);
        stream.write(this.dataType);
        RW.writeWord(stream, this.fieldLength);
        RW.write(stream, this.scale);
        stream.write(this.reserved2);
        RW.writeDWord(stream, this.incValue);
        stream.write(this.reserved3);
    }

    public int getFieldType() {
        int result = 0;
        switch (this.dataType) {
            case 'C': 
            case 'F': 
            case 'W': {
                result = 6;
                break;
            }
            case 'L': {
                result = 1;
                break;
            }
            case 'I': {
                result = 5;
                break;
            }
            case '$': 
            case '%': 
            case 'O': {
                result = 3;
                break;
            }
            case '@': 
            case 'D': 
            case 'T': {
                result = 2;
                break;
            }
            case 'Z': {
                result = 8;
            }
        }
        return result;
    }

    public void setDataType(int type) {
        switch (type) {
            case 0: {
                this.dataType = (char)85;
                break;
            }
            case 6: {
                this.dataType = (char)67;
                break;
            }
            case 1: {
                this.dataType = (char)76;
                break;
            }
            case 5: {
                this.dataType = (char)73;
                break;
            }
            case 3: {
                this.dataType = (char)79;
                break;
            }
            case 2: {
                this.dataType = (char)64;
                break;
            }
            case 8: {
                this.dataType = (char)90;
            }
        }
    }

    public String toString() {
        StringBuffer result = new StringBuffer(super.toString());
        result.append(", FieldName:");
        result.append(this.fieldName);
        result.append(", dataType:");
        result.append(this.dataType);
        result.append(", fieldLength:");
        result.append(this.fieldLength);
        result.append(", scale:");
        result.append(this.scale);
        result.append(", incValue:");
        result.append(this.incValue);
        return result.toString();
    }

    public static void main(String[] args) {
    }
}

